import 'dart:html';



class Loop {
  Loop(this.frame, this.fps) {
    speed = 1000 / fps;
  }

  num speed;
  final Function frame;
  final int fps;

  num _lastTimeStamp;

  Future start() async {
    while(true) {
      update(await window.animationFrame);
    }
  }

  void update(num delta) {
    final diff = delta - _lastTimeStamp;
    if (diff > speed) {
      _lastTimeStamp = delta;
      frame();
    }
  }
}